#include "my_num_types.h"
#include <stdlib.h> // for malloc

struct Integer CreateInt(const char* charDigs){
	long long n = strlen(charDigs);
	struct Integer myInt = {n,NULL};
	myInt.digs = (unsigned char*) malloc(n * sizeof(unsigned char));
	for(long long i = 0; i < n; i++){
		myInt.digs[i] = charDigs[n-i-1] - '0';
	}
	return myInt;
}

struct Integer CreateInt2(long long nDigs, unsigned char* const p_digs){
	struct Integer myInt = {nDigs,NULL};
	myInt.digs = (unsigned char*) malloc(nDigs * sizeof(unsigned char));
	memcpy(myInt.digs, p_digs, nDigs * sizeof(unsigned char));
	return myInt;
}

void DeleteInt(struct Integer* p_myInt){
	if(p_myInt->digs)
		free(p_myInt->digs);
	p_myInt->nDigs = 0;
}

void PrintInt(const struct Integer* p_myInt){
	for(long long i = 0; i < p_myInt->nDigs; i++){
		printf("%c", p_myInt->digs[ p_myInt->nDigs-1 -i ] + '0' );
	}
	printf("\n");
}

struct Integer SumInts(const struct Integer* p_myInt1, const struct Integer* p_myInt2){
	//check the required number of digigs
	long long nMax = p_myInt1->nDigs > p_myInt2->nDigs ? p_myInt1->nDigs: p_myInt2->nDigs; //get max
	char dig1, dig2, transfer = 0;
	for(long long i = 0; i < nMax; i++){
		if (i < p_myInt1->nDigs)
			dig1 = p_myInt1->digs[i];
		else
			dig1 = 0;
		if (i < p_myInt2->nDigs)
			dig2 = p_myInt2->digs[i];
		else
			dig2 = 0;
		
		transfer = (transfer + dig1 + dig2) / 10;
		//printf("transfer: %d\n", transfer);
	}

	if (transfer > 0)
		nMax++;
	struct Integer myIntSum = {nMax,NULL};
	myIntSum.digs = (unsigned char*) malloc(nMax * sizeof(unsigned char));
	//evaluate sum
	for(long long i = 0; i < nMax; i++){
		if (i < p_myInt1->nDigs)
			dig1 = p_myInt1->digs[i];
		else
			dig1 = 0;
		if (i < p_myInt2->nDigs)
			dig2 = p_myInt2->digs[i];
		else
			dig2 = 0;
		myIntSum.digs[i] = (transfer + dig1 + dig2) % 10;	
		transfer         = (transfer + dig1 + dig2) / 10;	
	}
	return myIntSum;
}

struct Integer MultiplyInts(const struct Integer* p_myInt1, const struct Integer* p_myInt2){
	unsigned char dig2, transfer;
	unsigned char *auxDigArr;
	struct Integer auxProd, partProd, prod = CreateInt("0");
	for(long long i = 0; i < p_myInt2->nDigs; i++){
		dig2 = p_myInt2->digs[i];

		auxDigArr = (unsigned char*) malloc((p_myInt1->nDigs + i + 1) * sizeof(unsigned char));
		//fill the beginning with zeros
		for(long long j = 0; j < i; j++)
			auxDigArr[j] = 0;
		transfer = 0;
		for(long long j = 0; j < p_myInt1->nDigs; j++){
			auxDigArr[i + j] = (transfer + (p_myInt1->digs[j] * dig2)) % 10;
			transfer         = (transfer + (p_myInt1->digs[j] * dig2)) / 10;
		}
		auxDigArr[p_myInt1->nDigs + i] = transfer;

		if(transfer == 0)
			partProd = CreateInt2(p_myInt1->nDigs + i    , auxDigArr);
		else
			partProd = CreateInt2(p_myInt1->nDigs + i + 1, auxDigArr);
		auxProd = prod;
		prod = SumInts(&auxProd, &partProd);
		DeleteInt(&partProd);
		DeleteInt(&auxProd);
		free(auxDigArr);
	}
	return prod;
}
